//
// Carver.h
//

// System includes.
#include <vector>
#include <stack>
#include <stdlib.h>		// needed for random()

// Engine includes.
#include "EventCollision.h"
#include "EventKeyboard.h"
#include "Object.h"
#include "ObjectList.h"

// Game includes
#include "Cell.h"
#include "maze.h"

using std::stack;
using std::vector;

class Carver : public df::Object {

 private:

  // Four directions for walls.
  enum DIR {NORTH, SOUTH, EAST, WEST};

  Cell maze[MAX_ROWS][MAX_COLS];// Maze cells.
  int num_rows, num_cols;       // Number of (rows, cols).
  int cur_row, cur_col;		// (Row, col) being visited.
  int distance, max_distance;	// To record max distance seen.
  int countdown;		// Countdown until next move.
  stack<Cell> trail;		// Keep track of visited cells.
  stack<Cell> longest;		// Keep track of longest trail.
  vector<DIR> live;             // Active visitation.

 public:
  Carver();
  void move();
  int eventHandler(const df::Event *e);
  int draw();
  void drawPath();
};
